var _simplifiedJSON = 1;
var _use_cookie = 1;
var pingTimer = 0;
var pingInterval = 0;
var pSent = 0;
var pRcvd = 0;
var mRcvd = 0;
var connected = 0;
var output;
var _websocket;
var prevMsgCnt = 0;
var rateTimer;
var supportOptimizedPauseResume = 0;
var sendTextEditor;
var receiveTextEditor;

var fields = ["BID", "ASK", "BIDSIZE", "ASKSIZE", "TRDPRC_1", "ACVOL_1", "QUOTIM", "TRDTIM_1", "TRADE_DATE", "HIST_CLOSE", "YRHIGH",  "YRLOW"];

var capNames = ["Unknown0",
				"Login", 
				"Unknown2",
				"Unknown3",
				"Source",
				"Dictionary", 
				"MarketPrice",
				"MarketByOrder",
				"MarketByPrice",
				"MarketMaker",
				"SymbolList",		// 10
				"ServiceProviderStatus",
				"History",
				"Headline",
				"Story",
				"ReplayHeadLine",
				"ReplayStory",
				"Transaction",
				"Unknown18",
				"Unknown19",
				"Unknown20",		// 20
				"Unknown21",
				"YieldCurve",
				"Unknown23",
				"Unknown24",
				"Unknown25",
				"Unknown26",
				"Contribution",
				"Unknown28",
				"ProviderAdmin",
				"Analalytics",		// 30
				"Reference",
				"Unknown32",
				"NewsTextAnalytics",
				"EconomicIndicator",
				"Poll",
				"Forcast",
				"MarketByTime",
				"System"
				];


var nextStreamId = 1;
var loginId = 0;
var srcDirId = 0;
var serviceInfos = [];
var subMap = new Map();

function init()
{
	//connect();
}

function initDefaultData(data) {
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(data), null, 2));
}

function initTextAreas() {
	sendTextArea = document.getElementById("sendText");
	sendTextEditor = CodeMirror.fromTextArea(sendTextArea, {
		lineNumbers: true,
		tabSize: 2,
		mode: {name: "javascript", json: true}
	});
	receiveTextArea = document.getElementById("receiveText");
	receiveTextEditor = CodeMirror.fromTextArea(receiveTextArea, {
		lineNumbers: true,
		tabSize: 2,
		readOnly: true,
		mode: {name: "javascript", json: true}
	});
	//insertLoginBasic();
}

function cleanAppend(editor, message) {
	currentSpot = editor.getScrollInfo();
	if(editor.getValue() != '') {
		editor.setValue(editor.getValue() + '\n');
		//editor.replaceSelection('\n');
	}
	editor.setValue(editor.getValue() + message);
	editor.scrollTo(currentSpot.left, currentSpot.top);
}

function clearSendText() {
	sendTextEditor.setValue('');
}

function insertLoginBasic() {
	msg = '{"Id":1,"Domain":"Login","Key":{"Name":"user","Elements":{"ApplicationId":"256","Position":"127.0.0.1"}}}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertLoginAuthentication() {
	msg = '{"Id":1,"Domain":"Login","Key":{"NameType":"AuthnToken","Elements":{"AuthenticationToken":"aBcDeFgHiJkLmNoPqRsTuVwXyZ","ApplicationId":"555","Position":"127.0.0.1"}}}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertPostingBasic() {
	msg = '{"Ack":true,"Domain":"MarketPrice","Id":2,"Message":{"Domain":"MarketPrice","Fields":{"ASK":45.57,"ASKSIZE":19,"BID":45.55,"BIDSIZE":18},"Id":0,"Type":"Update"},"PostId":1,"PostUserInfo":{"Address":"127.0.0.1","UserId":55555},"Type":"Post"}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertLoginClose() {
	msg = '{"Id":1,"Type":"Close","Domain":"Login"}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertMarketPriceSingle() {
	msg = '{"Id":2,"Key":{"Name":"TRI.N"}}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertMarketPriceBatch() {
	msg = '{"Id":2,"Key":{"Name":["TRI.N","IBM.N","T.N"]}}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertMarketPriceView() {
	msg = '{"Id":2,"Key":{"Name":"TRI.N"},"View":["BID","ASK","BIDSIZE"]}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertMarketPriceClose() {
	msg = '{"Id":2,"Type":"Close"}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertMarketPriceBatchClose() {
	msg = '{"Id":[3,4,5],"Type":"Close"}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertHeadlineBasic() {
	msg = '{"Id":2,"Domain":"Headline","Key":{"Name":"NFCP_UBMS"}}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertHeadlineClose() {
	msg = '{"Id":2,"Type":"Close","Domain":"Headline"}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertSourceBasic() {
	msg = '{"Id":2,"Domain":"Source","Key":{"Filter":255}}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function insertSourceClose() {
	msg = '{"Id":2,"Type":"Close","Domain":"Source"}';
	clearSendText();
	cleanAppend(sendTextEditor, JSON.stringify(JSON.parse(msg), null, 2));
}

function printIt(msg)
{
}

function clearReceiveText() {
	receiveTextEditor.setValue('');
}

function onHeartbeat()
{
	/*
	pRcvd++;
	document.getElementById("pingsReceived").innerHTML=pRcvd.toString();
	*/
}

function sendIt() {
	msg = sendTextEditor.getValue();
	//button = document.getElementById("goButton");
	//button.innerHTML = "Stop";
	//button.onclick = sendMarketPriceClose;
	//button.className = button.className.replace(/btn-success/i, "btn-danger");
	sendMsg(msg, false);
	cleanAppend(receiveTextEditor, "SENT:\n" + JSON.stringify(JSON.parse(msg), null, 2));
}

function sendMarketPriceClose() {
	
	msg = '{"Id":2,"Type":"Close"}';
	button = document.getElementById("goButton");
	button.innerHTML = "Run";
	button.onclick = sendMarketPrice;
	button.className = button.className.replace(/btn-danger/i, "btn-success");
	sendMsg(msg, false);
}

function onException(args)
{
	console.log("onException");
	console.log(args);
}

function disconnect() {
	createDisconnect();
	send();
}

function disconnect()
{
	if (_websocket)
		_websocket.close();
}

function connect()
{
	var checkHostname = document.getElementById("hostnameText").value;
	var pattern = new RegExp("[^\:]+:[0-9]{5}");
	document.getElementById("inputAlert").style.display = 'none';
	
	if( !pattern.test(checkHostname) ) 
	{
		document.getElementById("inputAlert").style.display = 'block';
		return;
	}
	
	if( connected )
		return;
	
	//	document.LoginType[0].disabled = true;
	//	document.LoginType[1].disabled = true;

	//	if (_use_cookie)
	//	{
	//		userBox = document.getElementById("userName");
	//		userName = userBox.value;
	//		positionBox = document.getElementById("userPosition");
	//		position = userPosition.value;
	//		appIdBox = document.getElementById("appId");
	//		appId = appIdBox.value;
		
	//		createCookie("position", position, "/", docDomain, 1);
	//		createCookie("applicationId", appId, "/", docDomain, 1);
	//	}
	//	else
	//	{
	//		eraseCookie("AuthToken","/", "");
	//		eraseCookie("AuthPosition","/", docDomain);
	//		eraseCookie("applicationId","/", docDomain);
	//	}

	if ("WebSocket" in window)
	{
		hostNameFull = document.getElementById("hostnameText").value;
		hostNameDelimited = hostNameFull.split(":");
		hostName = hostNameDelimited[0];
		portNumber = hostNameDelimited[1];
		document.getElementById("loaderInfo").innerHTML = "Connecting...";
		document.getElementById("loadIcon").className = "fa fa-spinner fa-spin fa-fw load-icon";
		var WS_URL = 'ws://' + hostName + ':' + portNumber + '/WebSocket';
		_websocket = new WebSocket(WS_URL, "tr_json2");
		_websocket.onopen = onOpen;
		_websocket.onclose = onClose;
		_websocket.onmessage = onMessage;
		_websocket.onerror = onError;
	}
	else
	{
		document.getElementById("loaderInfo").innerHTML = "WebSockets not supported on your browser.";
	} 
	clearWindow();
	pRcvd = 0;
	pSent = 0;
	mRcvd = 0;
	//document.getElementById("pingsReceived").innerHTML="0";
	//document.getElementById("pingsSent").innerHTML="0";
}

function clearWindow()
{
	//output.innerHTML = "" ;
}


function onOpen(evt)
{
	document.getElementById("loaderInfo").innerHTML = "Connected!";
	//rateTimer = setInterval(function(){doRate()}, 1000);
	connected = 1;
	document.getElementById("loadIcon").className = "fa fa-check fa-fw load-icon";
	document.getElementById("mainContent").style.pointerEvents = "auto";
	//sendLogin();
}

function onClose(evt){
	//document.getElementById("connectionStatus").innerHTML="<span class='error'>Disconnected</span>";
	//document.getElementById("loginStatus").innerHTML="<span class='error'>Closed</span>";
	//document.getElementById("srcStatus").innerHTML="<span class='error'>Closed</span>";
	clearInterval(pingTimer);
	pingTimer = 0;	
	clearInterval(rateTimer);
	//document.getElementById("msgRate").innerHTML = "0";
	rateTimer = 0;
	loginId = 0;
	connected = 0;

	// MJD - remove all open items here
	loginId = 0;
	srcDirId = 0; 
	nextStreamId = 1;
}

/*
function doRate()
{
	 var msgRate = mRcvd - prevMsgCnt;
	 prevMsgCnt = mRcvd;
	 document.getElementById("msgRate").innerHTML = msgRate.toString();
}
*/

function processLoginResponse(msg)
{
	if (!msg.State || (msg.State &&msg.State.Stream && msg.State.Stream == "Open"))
	{
		//document.getElementById("loginStatus").innerHTML="<span class='connected'>Active</span>";
		//if (msg.Id)
		//	loginId = msg.Id;
		//document.getElementById("loaderInfo").innerHTML = "Logged in!";
	}
	// Check for pause/resume support in key attrib
	/*
	if (msg.Key && msg.Key.Elements)
	{
		if (msg.Key.Elements.SupportPauseResume)
		{
			document.getElementById("pauseButton").disabled = false;
			document.getElementById("resumeButton").disabled = false;
		}
		else
		{
			document.getElementById("pauseButton").disabled = true;
			document.getElementById("resumeButton").disabled = true;
		}
		if (msg.Key.Elements.SupportOptimizedPauseResume)
		{
			document.getElementById("pauseAllButton").disabled = false;
			document.getElementById("resumeAllButton").disabled = false;
		}
		else
		{
			document.getElementById("pauseAllButton").disabled = true;
			document.getElementById("resumeAllButton").disabled = true;
		}
	}
	*/
	if (msg.Elements && msg.Elements.ClientToServerPingInterval)
	{
		if (  msg.Elements.ClientToServerPingInterval > 0)
		{
			//printIt("<p class = 'response'> PING Interval set to " +  msg.Elements.ClientToServerPingInterval + " seconds</p>");
			pingInterval = msg.Elements.ClientToServerPingInterval * 1000;
			//if (document.getElementById("sendPings").checked==true)
			//{
				pingTimer = setInterval(function(){sendPing()}, pingInterval);
			//}
		}
		else
			printIt("<p class = 'response'> Client to Server Pings Disabled</p>");
	}
}

function processResponse(msg)
{
	if (msg.State && msg.State.Stream && 
		(msg.State.Stream == "Closed" || 
		 msg.State.Stream == "ClosedRecover" ||
		 msg.State.Stream == "NonStreaming"))
	{
		// search through subList for streamId and remove if found
		/*
		subList = document.getElementById("subscribedList");

		if (!subList || !msg.Id)
			break;

		for (i=0; i < subList.length; i++)
		{
			if (subList.options[i].value == msg.Id)
			{
				subList.remove(i);
				break;
			}
		}
		*/
	}
}




function processStatus(msg)
{
	var domain = "";
	if (msg.Domain)
		domain = msg.Domain;
	else
		domain = "MarketPrice";

	switch(domain)
	{
	case "LOGIN":
		{
			if (msg.State && msg.State.Stream && 
				(msg.State.Stream == "Closed" || msg.State.Stream == "ClosedRecover"))
			{
				loginId = 0;
				srcDirId = 0;
				/*
				subList = document.getElementById("subscribedList");
				if (subList)
					subList.length = 0;
				nextStreamId = 1;
				document.getElementById("pauseButton").disabled = true;
				document.getElementById("resumeButton").disabled = true;
				document.getElementById("pauseAllButton").disabled = true;
				document.getElementById("resumeAllButton").disabled = true;
				*/
			}
			break;
		}
	case "SOURCE":
		{
			if (msg.State && msg.State.Stream && 
				(msg.State.Stream == "Closed" || msg.State.Stream == "ClosedRecover"))
			{
				//document.getElementById("srcStatus").innerHTML="<span class='error'>Closed</span>";
				srcDirId = 0;
			}
			break;
		}
	default:
		{
			if (msg.State && msg.State.Stream && 
				(msg.State.Stream == "Closed" || msg.State.Stream == "ClosedRecover" || msg.State.Stream == "NonStreaming"))
			{
				// search through subList for streamId and remove if found
				/*
				subList = document.getElementById("subscribedList");

				if (!subList || !msg.Id)
					break;

				for (i=0; i < subList.length; i++)
				{
					if (subList.options[i].value == msg.Id)
					{
						subList.remove(i);
						break;
					}
				}
				*/
			}
			break;
		}
	}
}

function processLoginStatus(msg)
{
	if (_simplifiedJSON)
	{
		if (msg.Id)
		{
		}

		var state = msg.State;
		if (state)
		{
			var stream = state.Stream;
			if (stream && stream == "Closed")
			{
				//document.getElementById("loginStatus").innerHTML="<span class='error'>Closed</span>";
				//document.getElementById("srcStatus").innerHTML="<span class='error'>Closed</span>";
				loginId = 0;
				srcDirId = 0;
				/*
				subList = document.getElementById("subscribedList");
				if (subList)
					subList.length = 0;
				*/
				nextStreamId = 1;
			}
		}
	}
	else if (msg.d)
	{
		var status = msg.s;
		if (status)
		{
			var streamStatus = status.s;
			if (streamStatus && streamStatus == 0)
			{
				//document.getElementById("loginStatus").innerHTML="<span class='error'>Closed</span>";
				//document.getElementById("srcStatus").innerHTML="<span class='error'>Closed</span>";
				loginId = 0;
				srcDirId = 0;
				if (subList)
					subList.length = 0;
				nextStreamId = 1;
			}			
		}
	}
}

function serviceInfo(serviceName, serviceId, capabilities)
{
	this.serviceName = serviceName;
	this.serviceId = serviceId;
	this.capabilities = capabilities;
}

function addServiceInfo(servInfo)
{
	/*
	var serviceList = document.getElementById("serviceList");
	var opt;
	for (i = 0; i < serviceList.options.length; i++)
	{
		if ( serviceList.options[i].text == servInfo.serviceName)
		{
			opt = serviceList.options[i];
			break;
		}
	}
	if (!opt)
	{
		opt = document.createElement("option");
		opt.text=servInfo.serviceName;
		//		opt.text=elementListArray[elementIndex].Data;
		opt.value=servInfo.serviceId;
		opt.selected=true;
		serviceList.options.add(opt);
	}

	for (i = 0; i < serviceList.options.length; i++)
	{
		if ( serviceList.options[i].text == servInfo.serviceName)
		{
			serviceInfos[i] = servInfo;
			break;
		}
	}
	addCapabilities(servInfo);
	*/
}

function changeService()
{
	/*
	var list = document.getElementById("serviceList");
	//	var value = JSON.parse(list.options[list.selectedIndex].value);
	addCapabilities(serviceInfos[list.selectedIndex]);
	*/
}



function addCapabilities(servInfo)
{
	/*
	var list = document.getElementById("domainList");
	while (list.firstChild)
	{
		list.removeChild(list.firstChild);
	}

	for (var capIndex in servInfo.capabilities)
	{
		opt = document.createElement("option");
		if (servInfo.capabilities[capIndex] < capNames.length + 1)
			opt.text = capNames[servInfo.capabilities[capIndex]];
		else
			opt.text = servInfo.capabilities[capIndex];


		opt.value = servInfo.capabilities[capIndex];

		if (opt.value == 6)
			opt.defaultSelected = true;

		list.options.add(opt);
	}
	*/
}


function processSourceResponse(msg)
{
	/*
	var serviceId = 0; 
	var serviceName = "";
	var capabilities;

	if (_simplifiedJSON)
	{
		if (!msg.state || (msg && msg.state && msg.State.Stream && msg.State.Stream == "OPEN"))
		{
			document.getElementById("srcStatus").innerHTML="<span class='connected'>Active</span>";
		}

		if (msg.Map && msg.Map.Entries)
		{
			mapArray = msg.Map.Entries;
			for (var mapIndex in mapArray)
			{
				serviceId = mapArray[mapIndex].Key;

				if (mapArray[mapIndex].FilterList && mapArray[mapIndex].FilterList.Entries)
				{
					filterArray = mapArray[mapIndex].FilterList.Entries;
					for (var filterIndex in filterArray)
					{
						if (filterArray[filterIndex].Id == 1)
						{
							if (filterArray[filterIndex].Elements)
							{
								if (filterArray[filterIndex].Elements && 
									filterArray[filterIndex].Elements.Name &&
									filterArray[filterIndex].Elements.Capabilities &&
									filterArray[filterIndex].Elements.Capabilities.Data &&
									filterArray[filterIndex].Elements.Capabilities.Data.Data)
								{
									serviceName = filterArray[filterIndex].Elements.Name;
									capabilities = filterArray[filterIndex].Elements.Capabilities.Data.Data;
								}
							}
						}
					}
				}
				var servInfo = new serviceInfo(serviceName, serviceId, capabilities);
				addServiceInfo(servInfo);								
			}
		}
	}
	else
	{
		// Standard JSON
		if (msg.b)
		{	msgBase = msg.b;
			if (msgBase.c != 2)
			{
				printIt("<p class = 'response'> Only handling SourceDir Refreshes</p>");
				return;
			}
		}
		// MJD check stream status first
		document.getElementById("srcStatus").innerHTML="<span class='connected'>Active</span>";
		if (msg.d && msg.d.d)
		{
			mapArray = msg.d.d;
			for (var mapIndex in mapArray)
			{
				serviceId = mapArray[mapIndex].k;

				if (mapArray[mapIndex].d.d)
				{
					filterArray = mapArray[mapIndex].d.d;
					for (var filterIndex in filterArray)
					{
						if (filterArray[filterIndex].i == 1)
						{
							if (filterArray[filterIndex].d)
							{
								elementListArray = filterArray[filterIndex].d.d;
								for (var elementIndex in elementListArray)
								{
									switch (elementListArray[elementIndex].n)
									{
									case "Name":
										{
											serviceName = elementListArray[elementIndex].d;
											break;
										}
									case "Capabilities":
										{
											capabilities = elementListArray[elementIndex].d.d;
										}
									}
								}
							}
						}
					}
				}
				var servInfo = new serviceInfo(serviceName, serviceId, capabilities);
				addServiceInfo(servInfo);								
			}
		}

	}
	*/
}

function processMessage(msg, cnt, len)
{
	var msgType;
	if (_simplifiedJSON)
	{
		if (msg.Type)
			msgType = msg.Type;
	}
	else if (msg.b && msg.b.c)
		msgType = msg.b.c;
			
	switch(msgType)
	{
	case 1:  // Request
	case "Request":
		{
			msgType = "REQUEST";
			break;
		}
	case 2:  // Response
	case "Refresh":
		{
			if (msg.Domain)
			{
				if (msg.Domain == "Login")
					processLoginResponse(msg);
				else if (msg.Domain == "Source")
					processSourceResponse(msg);
				else
					processStatus(msg)
			}
			else
			{
				processStatus(msg);
			}

			msgType = "RESPONSE";
			break;
		}
	case 3:
	case "Status":
		{
			msgType = "STATUS";
			processStatus(msg);
			break;
		}
	case 4:
	case "Update":
		{
			msgType = "UPDATE";
			break;
		}
	case 5:
	case "Close":
		{
			msgType = "CLOSE";
			break;
		}
	case 6:
	case "Ack":
		{
			msgType = "ACK";
			break;
		}
	case 7:
	case "Generic":
		{
		msgType = "GENERIC";
		break;
		}
	case 8:
	case "Post":
		{
			msgType = "POST";
			break;
		}
	default:
		msgType = "INVALID";
		break;
	}
}

function onMessage(evt)
{
	
	if (evt.data == "")
	{
		pRcvd++;
	}
	else
	{
		
		
		var parsedMsg = JSON.parse(evt.data.toString());
		
		var msgString = "RECEIVED:\n" + JSON.stringify(parsedMsg, null, 2);
		cleanAppend(receiveTextEditor, msgString);

		for (var i = 0; i < parsedMsg.length; ++i)
			processMessage(parsedMsg[0]);
	}
	/**
	//called on receipt of message for webSocket
	if (evt.data == "")
	{
		
		//document.getElementById("pingsReceived").innerHTML=pRcvd.toString();
		//printIt("<p class = 'response'>PING RECEIVED! </p>");
	}
	else
	{
		if (evt.data.charAt(0) == "{")
		{
			// One Message in event
			mRcvd++;
			//document.getElementById("msgsReceived").innerHTML=mRcvd.toString();
			try
			{
				var msgString = evt.data.toString();
				var len = msgString.length;
				parsedMsg = JSON.parse(msgString);
				processMessage(parsedMsg, 0, len);

			}
			catch(err)
			{

				// MJD - Check to see if there is a missing value, if there is make it null and continue
				msgString = new String(evt.data.toString());
				var errorPos1 = -1;
				var errorPos2 = -1
					while ( ((errorPos1 = msgString.indexOf("\":,") ) != -1)  ||
							((errorPos2 = msgString.indexOf("\":}") ) != -1) )


					{
						var tmpString = new String();

						if (errorPos1 != -1)
						{
							tmpString = msgString.substr(0, errorPos1 + 2);
							tmpString += "null,"; 
							tmpString += msgString.substr(errorPos1 + 3, msgString.Length);
							msgString = tmpString.toString();
						}
						if (errorPos2 != -1)
						{
							tmpString = msgString.substr(0, errorPos2 + 2);
							tmpString += "null}"; 
							tmpString += msgString.substr(errorPos2 + 3, msgString.Length);
							msgString = tmpString.toString();
						}

						
					}
				try
				{
					var parsedMsg = JSON.parse(msgString);
					processMessage(parsedMsg, 0, 0);
				}
				catch(err)
				{
					printIt("<p class = 'error'>ERROR in JSON MSG:<BR>" + err.toString() + "<BR>" + msgString + "</p>");
				}
				
				return;
			}
		}
		else
		{
			// Event Contains multiple messages
			var msg = evt.data.toString();
			var length = msg.length;
			var used = 0;
			var msgCnt = 1;
			var msgLength = 0;
			var msgLengthStr;
			while (length - used > 4)
	 		{
				msgLengthStr = msg.substr(used, 4);
				msgLength = parseInt(msgLengthStr, 10);
				used += 4;
				var aMsg = msg.substr(used, msgLength);
				mRcvd++;
				//document.getElementById("msgsReceived").innerHTML=mRcvd.toString();
				try
				{
					var parsedMsg = JSON.parse(aMsg);
					processMessage(parsedMsg, msgCnt, msgLengthStr);
				}
				catch(err)
				{
					printIt("<p class = 'error'>ERROR in JSON MSG: <BR>" +  msg + "</p>");
					return;
				}
				used += msgLength;
				msgCnt++;
			}
		}	
	}**/
}

function onError(evt)
{
	printIt("<p class = 'error'>ERROR: " + evt.data + "</p>");
}

function sendMsg(msg, login)
{
	_websocket.send(msg);
/*
	if (msg == "")
	{
		_websocket.send(msg);
		return;
	}


	login = typeof login !== 'undefined' ? login : false;
	if(connected == 0)
	{
		printIt("<p class='error'>ERROR: Unable to Send Message.... Connect First ?" + "</p>");
		return;
	}

	if(loginId || login && msg != "")
	{	
		//if (document.getElementById("prettyPrint").checked)
		//{
			
			//var jsonMsg = JSON.parse(msg);
			
			//var msgString = JSON.stringify(jsonMsg, null, 4);
			//printIt("<p>MESSAGE(s) SENT:<pre>" + msgString + "</pre></p>");
		//}
		//else
		//	printIt("<p>MESSAGE(s) SENT:" + msg + "</p>");
		
		_websocket.send(msg);
	}
	else
		printIt("<p class='error'>ERROR: Unable to Send Message.... Login First ?" + "</p>");
	*/
}

function checkPings(checkbox)
{
	if (checkbox.checked && pingTimer == 0)
		pingTimer = setInterval(function(){sendPing()}, pingInterval);
	else if (pingTimer !=0)
	{
		clearInterval(pingTimer);
		pingTimer = 0;
	}	
}

function sendPing(){
	//if( connected == 0 || document.getElementById("sendPings").checked==false)
	if( connected == 0)
	{
		clearInterval(pingTimer);
		pingTimer = 0;
	}
	else
	{
		sendMsg("");
		pSent++;
		//document.getElementById("pingsSent").innerHTML=pSent.toString();
		//printIt("<p>MESSAGE SENT: PING" + "</p>");
	}
}

function sendLogin(){

	userName = "root";
	position = "127.0.0.1";
	appId = "256";

	/*
	var msg = '{"Id":'+ loginId + ',"Domain":"Login",' +
		'"Key":{"NameType":"AuthnToken",' + 
		'"Elements":{"AuthenticationToken":"' + userName + '",' +
		'"ApplicationId":"' + appId + '",' +
		'"Position":"' + position + '"}}}';
	*/
	var msg = '{"Id":1,"Domain":"Login","Key":{"Name":"' + userName + '","Elements":{"ApplicationId":"' + appId + '","Position":"' + position + '"}}}'
	sendMsg(msg, true);
}


function sendLoginClose(){
	if(!loginId)
		return;
	var msg = '{"Id":' + loginId + ',"Type":"Close","Domain":"Login"}';

	sendMsg(msg);
	
	//subList = document.getElementById("subscribedList");
	//subList.length = 0

	//subList = document.getElementById("subscribedList");
	//if (subList)
	//	subList.length = 0;

	clearInterval(pingTimer);
	srcDirId = 0;
	loginId = 0;
	nextStreamId = 1;
}

/******************************************************* IGNORE BELOW ***************************************************************/
/*
function SetSimplifiedJSON(simplified)
{
	_simplifiedJSON = simplified;
	if (!simplified)
	{
		document.getElementById("defaultDomain").checked=false;
		document.getElementById("defaultDomain").disabled=true;
		document.getElementById("defaultService").checked=false;
		document.getElementById("defaultService").disabled=true;
	}
	else
	{
		document.getElementById("defaultDomain").checked=true;
		document.getElementById("defaultDomain").disabled=false;
		document.getElementById("defaultService").checked=true;
		document.getElementById("defaultService").disabled=false;
	}
}



function readCookie(name) {
	var nameEQ = name + "=";
	var ca = document.cookie.split(';');
	for(var i=0;i < ca.length;i++) {
		var c = ca[i];
		while (c.charAt(0)==' ') c = c.substring(1,c.length);
		if (c.indexOf(nameEQ) == 0) return c.substring(nameEQ.length,c.length);
	}
	return null;
}



function createCookie(name,value,path,domain,days) {
	var cookie = name + "=" + value + ";";
    if (days) {
        var date = new Date();
        date.setTime(date.getTime()+(days*24*60*60*1000));
        var expires = " expires="+date.toGMTString() + ";";
		cookie += expires;
    }
	if (path)
		cookie += "path=" + path + ";";
	
	if (domain)
		cookie += "domain=" + domain + ";";

	document.cookie = cookie;
}

function eraseCookie(name, path, domain) {
    createCookie(name,"",path,domain,-1);
}
function sendSrcDir(){
	if(!loginId)
	{
		printIt("<p class='error'>ERROR: Unable to Send Message.... Login First ?" + "</p>");
		return;
	}
	srcDirId = nextStreamId++;
	if (_simplifiedJSON)
		var msg = '{"Id":'+ srcDirId +',"Type":"Request","Domain":"Source","Key":{"Filter":255}}';
	else
		var msg = '{"b":{"s":' + srcDirId + ',"c":1,"t":4,"f":0},"k":{"x":255}}';

	sendMsg(msg);
}

function closeSrcDir(){
	
	if (srcDirId == 0)
		return;

	if (_simplifiedJSON)
	{
		var msg = '{"Id":' + srcDirId + ',"Type":"Close","Domain":"Source"}';
	}
	else
	{
		var msg = '{"b":{"s":' + srcDirId + ',"c":5,"t":4,"f":0}}';
	}
	sendMsg(msg);
	srcDirId = 0;
	document.getElementById("srcStatus").innerHTML="<span class='error'>Closed</span>";
}

function checkViewAll(checkbox)
{
	fields.forEach(function (item, index, array) {
      		if (checkbox.checked)
				document.getElementById(item).checked=true;
			else
				document.getElementById(item).checked=false;
		});
}

function getViewList()
{
	var count = 0;
	var viewList = "";

	var fidsByNum = document.getElementById("useFids").checked==true;

	fields.forEach(function (item, index, array)
	{
		if(document.getElementById(item).checked==true)
		{
			if (count == 0)
			{
				if (_simplifiedJSON)
					if (!fidsByNum)
						viewList = '[' + '"' + item + '"';
					else
						viewList = '[' + document.getElementById(item).value;
				else
					viewList = '{"n":":ViewType","t":4,"d":1},{"n":":ViewData","t":15,"d":{"t":3,"d":[' + document.getElementById(item).value;
				count++;
			}
			else
			{
				if (_simplifiedJSON && !fidsByNum)
				{
					viewList += ',"' + item + '"';
				}
				else
					viewList += ',' + document.getElementById(item).value;
				count++;
			}
		}
	});

	if ( count > 0)
	{
		if (_simplifiedJSON )
			viewList += ']';
		else
			viewList += ']}}';
	}
	return viewList;
}

function pause(doPause)
{
	var fromList;
	var toList;

	if (doPause)
	{
		fromList = document.getElementById("subscribedList");
		toList = document.getElementById("pausedList");
	}
	else
	{
		fromList = document.getElementById("pausedList");
		toList = document.getElementById("subscribedList");
	}

	var anItem = fromList.options[fromList.selectedIndex];
	fromList[fromList.selectedIndex] = null;

	if (!anItem)
		return;

	toList.options.add(anItem);
	domain = subMap.get(anItem.value).domain;

	if (_simplifiedJSON)
	{
		var msg = '{"Id":' + anItem.value  + ',"Type":"Request"' + ',"Refresh":false';
		if (doPause)
			msg += ',"Pause":true';
		if (subMap.get(anItem.value).domain != 6)
			msg += ',"Domain":"' + capNames[subInfo.domain] + '"';
			
		msg +=',"Key":{"Name":"' + anItem.text + '"}}';
	}
	else
	{
		msg = '{"b":{"s":' + anItem.value + ',"c":1,"t":' + domain + ',"f":0},"n":1';
		if (doPause)
			msg += ',"h":1';
		msg += ',"k":{"n":"' + anItem.text + '","s":' + subMap.get(anItem.value).serviceId +'}}';
	}
	sendMsg(msg);
} 


function pauseAll(doPause)
{
	if (!loginId)
		return;


	if (doPause)
	{
		fromList = document.getElementById("subscribedList");
		toList = document.getElementById("pausedList");
	}
	else
	{
		fromList = document.getElementById("pausedList");
		toList = document.getElementById("subscribedList");
	}



	var numOptions = fromList.options.length;
	for (i=0; i < numOptions; i++)
	{
		var anItem = fromList.options[0];
		fromList.remove(0);
		if (anItem)
			toList.options.add(anItem);
	}

	userBox = document.getElementById("userName");
	userName = userBox.value;
	userBox = document.getElementById("userName");
	userName = userBox.value;
	positionBox = document.getElementById("userPosition");
	position = userPosition.value;
	appIdBox = document.getElementById("appId");
	appId = appIdBox.value;
	
	if (_simplifiedJSON)
	{
		var msg = '{"Id":' + loginId  + ',"Type":"Request"' + ',"Domain":"Login","Refresh":false' + 
			',"Key":{"Name":"' + userName + '","NameType":"AuthnToken"}';
			
		if (doPause)
			msg += ',"Pause":true}';
		else
			msg += '}';
	}
	else
	{
		var msg = '{"b":{"c":1,"f":0,"s":' + loginId +',"t":1}' +
			',"k":{"t":5,"n":"' + userName + '"},"n":1';
		if (doPause)
			msg += ',"h":1}';
		else
			msg += '}';
	}
	sendMsg(msg);
} 

function unsubscribe()
{
	subList = document.getElementById("subscribedList");
	var anItem = subList.options[subList.selectedIndex];
	if (anItem)
	{
		subinfo = subMap.get(anItem.value);
		subMap.delete(anItem.value);
	}
	if (_simplifiedJSON)
	{
		var msg = '{"Id":' + anItem.value  + ',"Type":"Close"';
		if (subInfo.domain != 6)
			msg += ',"Domain":"' + capNames[subInfo.domain] + '"';
		msg += '}';
	}		
	else
		var msg = '{"b":{"s":' + anItem.value  + ',"c":5,"t":' + domain + ',"f":0}}';

	anItem.text = null;	// Clears the current item.  only really needed if last item. 
	subList[subList.selectedIndex] = null;
	sendMsg(msg);
} 

function unsubscribeAll()
{
	subList = document.getElementById("subscribedList");
	pausedList = document.getElementById("pausedList");
	if (subList.length == 0 && pausedList.length == 0) 
		return;
	var msg = "";
	var comma = false;
	if (_simplifiedJSON)
	{
		msg = '{"Type":"Close","Id":[';
		for (i=0; i < subList.length; i++)
		{
			if (!comma)
			{
				msg += subList.options[i].value;
				comma = true;
			}
			else
				msg += ',' + subList.options[i].value;
		}
		
		for (i=0; i < pausedList.length; i++)
		{
			if (!comma)
			{
				msg += pausedList.options[i].value;
				comma = true;
			}
			else
				msg += ',' + pausedList.options[i].value;
		}


		msg += ']}';
	}
	else
	{
		for (i=0; i < subList.length; i++)
		{
			if (i == 0)
			{
				msg = '{"b":{"s":' + subList.options[i].value + ',"c":5,"t":6,"f":5}' +
					',"g":1,"d":{"d":[{"n":":StreamIdList","t":15,"d":{"t":3, "d":[' + subList.options[i].value;
			}
				
			else
				msg += ',' + subList.options[i].value;
		}
		msg += ']}}]}}';
	}

	subList.length = 0;
	pausedList.length = 0;
	sendMsg(msg);
}


function subscribe()
{
	var serviceId = 0;
	var domain = 0;
	var domainName = "";

	if (_simplifiedJSON &&
		document.getElementById("defaultDomain").checked==true)
	{
		domainName="MarketPrice";
		domain=6;
	}
	else
	{
			domainList = document.getElementById("domainList");
			if (domainList.length == 0)
			{
				printIt("<p class='error'>ERROR: No Domain Specified .... Request Source Directory  First ?" + "</p>");
				return;
			}
			domain = domainList.options[domainList.selectedIndex].value;
			domainName = capNames[domain];
	}


	if (!_simplifiedJSON ||	document.getElementById("defaultService").checked==false)
	{
		serviceList = document.getElementById("serviceList");
		serviceId = serviceList.options[serviceList.selectedIndex].value;
	}

	nameBox = document.getElementById("itemName");
	name = nameBox.value;

	var subList = document.getElementById("subscribedList");
	var opt;

	var view = getViewList();
	var msg;


	if (_simplifiedJSON)
	{
		msg = '{"Id":' + nextStreamId;
		if (domainName != "MarketPrice")
			if (domainName && domainName.substring(0,7) == "Unknown")
				msg += ',"Domain":' + domain;
			else
				msg += ',"Domain":"' + domainName + '"';

		if (document.getElementById("snapShot").checked==true)
		{
			msg += ',"Streaming":false';
		}

		if (serviceId)
			msg += ',"Key":{"ServiceId":' + serviceId + ',"Name":';
		else
			msg += ',"Key":{"Name":';
		
		var itemArray = name.split(" ");

		if (itemArray.length > 1)
		{
			// Batch Request
			msg += '[';
			var count = 0;
			nextStreamId++;
			for (i=0; i < itemArray.length; i++)
			{
				if (count)
					msg += ',';
				msg += '"' + itemArray[i] + '"';
				count++;
				opt = document.createElement("option");
				opt.text=itemArray[i];
				opt.value=nextStreamId++;
				subList.options.add(opt);
				subInfo = {"serviceId":serviceId, "domain":domain};
				subMap.set(opt.value, subInfo);
			}
			msg += ']}';
		}
		else 
		{	
			// No Batch single item
			opt = document.createElement("option");
			opt.text=name;
			opt.value=nextStreamId;
			subList.options.add(opt);
			subInfo = {"serviceId":serviceId, "domain":domain};
			subMap.set(opt.value, subInfo);
			msg += '"' + name +'"}';
			nextStreamId++;
		}

		if (view)
		{
			msg += ',"View":' + view + '}';
		}
		else
		{
			msg += '}';
		}
	}
	else	// Standard JSON
	{
		var itemArray = name.split(" ");
		msg = '{"b":{"s":' + nextStreamId + ',"c":1,"t":' + domain;

		if (itemArray.length > 1)
		{
			// Batch request
			if (view)
				msg += ',"f":5},"k":{"s":' + serviceId + '},"v":1,"g":1,"d":{"d":[';
			else
				msg += ',"f":5},"k":{"s":' + serviceId + '},"g":1,"d":{"d":[';

			msg += '{"n":":ItemList","t":15,"d":{"t":17,"d":[';
				
			var count = 0;
			nextStreamId++;
			for (i=0; i < itemArray.length; i++)
			{
				if (count)
					msg += ',';
				msg += '"' + itemArray[i] + '"';
				count++;
				opt = document.createElement("option");
				opt.text=itemArray[i];
				opt.value=nextStreamId++;
				subList.options.add(opt);
				subInfo = {"serviceId":serviceId, "domain":domain};
				subMap.set(opt.value, subInfo);
			}
			if (view)
				msg += ']}},' + view + ']}}';
			else
				msg += ']}}]}}';
		}
		else
		{
			// No Batch, single item.
			if (view)
				msg +=  ',"f":5}';
			else
				msg +=  ',"f":0}';

			msg += ',"k":{"s":' + serviceId + ',"n":"' + name + '"}'

			opt = document.createElement("option");
			opt.text=name;
			opt.value=nextStreamId;
			subList.options.add(opt);
			subInfo = {"serviceId":serviceId, "domain":domain};
			subMap.set(opt.value, subInfo);
			nextStreamId++;

			if (view)
				msg += ',"v":1,"d":{"d":[' + view + ']}}';
			else
				msg += '}';
		}
	}
	sendMsg(msg);
}


function submitEnter(field, e)
{
	if (window.event) 
		keycode = window.event.keyCode; 
	else if (e) 
		keycode = e.which; 
	else 
		return true; 
	if (keycode == 13) 
	{ 
		//myfield.form.submit(); 
		subscribe();
		return false; 
	} 
	else 
		return true;
}

function domainSelected()
{
	document.getElementById("defaultDomain").checked=false;
	document.getElementById("viewAll").checked=false;
	checkViewAll(document.getElementById("viewAll"));
}
*/